
#include "badge_init.h"
#include "badge_iru.h"
#include <msp430x14x.h>

unsigned char iru_comms_spi(unsigned char opcode, unsigned char out_data);

unsigned char badge_iru_status(void)
{
  return(iru_comms_spi(IRU_GET_STATUS,0));
}
unsigned char badge_iru_get_uart_byte(void)
{
  return(iru_comms_spi(IRU_GET_UART,0));
}
unsigned char badge_iru_get_ir_byte(void)
{
  return(iru_comms_spi(IRU_GET_IR,0));
}
void badge_iru_send_uart_byte(unsigned char out_byte)
{
  iru_comms_spi(IRU_SEND_UART,out_byte);
}
void badge_iru_send_ir_byte(unsigned char out_byte)
{
  iru_comms_spi(IRU_SEND_IR,out_byte);
}

unsigned char iru_comms_spi(unsigned char opcode, unsigned char out_data)
{
  unsigned char tmp_rx;
  unsigned int to_tick;

  IFG1 &= ~URXIFG0;
  while ((IFG1 & UTXIFG0) == 0);          // USART0 TX buffer ready?
  P2OUT &= ~(IRU_CS);                        // Latch IRU
  TXBUF0 = opcode;
  to_tick = 25000;
  while ((IFG1 & URXIFG0) == 0) {
    if (--to_tick == 0) return(0);
  };
  tmp_rx = RXBUF0;
  while ((IFG1 & UTXIFG0) == 0);          // USART0 TX buffer ready?
  TXBUF0 = out_data;
  while ((UTCTL0 & TXEPT) == 0);
  P2OUT |= IRU_CS;
  to_tick = 25000;
  while ((IFG1 & URXIFG0) == 0) {
      if (--to_tick == 0) return(0);
  };
  return(RXBUF0);
}
