#ifndef BADGE_RF_H
#define BADGE_RF_H

// badge rf opcodes
#define RF_ON_OPCODE            0x01
#define RF_OFF_OPCODE           0x02
#define GET_SETTINGS_OPCODE     0x03
#define GET_STATUS_OPCODE       0x04
#define TX_BUFFER_CLEAR_OPCODE  0x05
#define RX_BUFFER_CLEAR_OPCODE  0x06
#define GET_RX_PACKET_OPCODE    0x07
#define SEND_TX_OPCODE          0x08

// handle_rf_byte RETURN CODES
#define NOTHING_NEW             0
#define NEW_RX_PACKET           1
#define TX_OKAY                 2
#define TX_BUFFER_FULL          3
#define TX_FAILED               4
#define NEW_STATUS              5
#define RF_OFF                  6
#define RF_OFF_FAILED           7
#define RF_ON                   8
#define RF_ON_FAILED            9
#define RX_BUFFER_CLEAR         10
#define RX_BUFFER_CLEAR_FAILED  11
#define TX_BUFFER_CLEAR         10
#define TX_BUFFER_CLEAR_FAILED  11
#define RF_SETTINGS_OKAY        12
#define RF_SETTINGS_FAILED      13


typedef struct {
  unsigned char current_pid;
  unsigned char incoming_packet[DATA_BUFFER_LENGTH];
  unsigned char rf_uart_state;
  unsigned char rf_uart_bytes;
} BADGE_RF_STATE;

BADGE_RF_STATE badgeRFState;



void init_rf_state_machine(void);
void send_rf_packet(unsigned char flags, unsigned char destH, unsigned char destL, unsigned char dataLen, unsigned char *dataTp);
void set_rf_settings(unsigned char addrH, unsigned char addrL, unsigned char ackTO, unsigned char ackAttempts);
void get_rf_status(void);
void get_rf_packet(void);
void turn_rf_off(void);
void turn_rf_on(void);
void clear_rf_tx_buffer(void);
void clear_rf_rx_buffer(void);
unsigned char handle_rf_byte(unsigned char new_byte, unsigned char *newStatus, unsigned char *rfPacket);

#endif
